use bevy::prelude::*;
use bevy_ecs_ldtk::prelude::*;

use crate::GameState;

pub struct LdtkPlugin;

#[derive(Default, Resource)]
pub struct WorldConfig {
    pub path: String,
}

impl Plugin for LdtkPlugin {
    fn build(&self, app: &mut App) {
        app.init_resource::<WorldConfig>()
            .add_plugins(bevy_ecs_ldtk::LdtkPlugin)
            .add_systems(OnEnter(GameState::Loading), spawn_world)
            .insert_resource(LevelSelection::Uid(0));
    }
}

fn spawn_world(mut commands: Commands, asset_server: Res<AssetServer>, config: Res<WorldConfig>) {
    commands.spawn(LdtkWorldBundle {
        ldtk_handle: asset_server.load(&config.path),
        ..default()
    });
}
